<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_17) on Fri Dec 04 18:31:05 CET 2009 -->
<TITLE>
VarInt
</TITLE>

<META NAME="keywords" CONTENT="ch.javasoft.math.varint.VarInt interface">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="VarInt";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/VarInt.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../ch/javasoft/math/varint/LongVarInt.html" title="class in ch.javasoft.math.varint"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarIntCache.html" title="interface in ch.javasoft.math.varint"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?ch/javasoft/math/varint/VarInt.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="VarInt.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
ch.javasoft.math.varint</FONT>
<BR>
Interface VarInt</H2>
<DL>
<DT><B>All Superinterfaces:</B> <DD><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&lt;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&gt;</DD>
</DL>
<DL>
<DT><B>All Known Implementing Classes:</B> <DD><A HREF="../../../../ch/javasoft/math/varint/BigIntegerVarInt.html" title="class in ch.javasoft.math.varint">BigIntegerVarInt</A>, <A HREF="../../../../ch/javasoft/math/varint/IntVarInt.html" title="class in ch.javasoft.math.varint">IntVarInt</A>, <A HREF="../../../../ch/javasoft/math/varint/LongVarInt.html" title="class in ch.javasoft.math.varint">LongVarInt</A>, <A HREF="../../../../ch/javasoft/math/varint/VarIntNumber.html" title="class in ch.javasoft.math.varint">VarIntNumber</A></DD>
</DL>
<HR>
<DL>
<DT><PRE>public interface <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.19"><B>VarInt</B></A><DT>extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&lt;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&gt;</DL>
</PRE>

<P>
A VarInt is an integer of variable length. Short values are simply
 backed with a byte, int or long value. Long integers are backed
 with an array of bytes. 
 <p>
 Subclasses usually extend the <A HREF="../../../../ch/javasoft/math/varint/VarIntNumber.html" title="class in ch.javasoft.math.varint"><CODE>VarIntNumber</CODE></A> class.
<P>

<P>
<DL>
<DT><B>See Also:</B><DD><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/math/BigInteger.html" title="class or interface in java.math"><CODE>BigInteger</CODE></A>, 
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang"><CODE>Number</CODE></A></DL>
<HR>

<P>
<!-- =========== FIELD SUMMARY =========== -->

<A NAME="field_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Field Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;<A HREF="../../../../ch/javasoft/math/varint/IntVarInt.html" title="class in ch.javasoft.math.varint">IntVarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#ONE">ONE</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The VarInt constant one.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;<A HREF="../../../../ch/javasoft/math/varint/IntVarInt.html" title="class in ch.javasoft.math.varint">IntVarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#TEN">TEN</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The VarInt constant ten.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;<A HREF="../../../../ch/javasoft/math/varint/IntVarInt.html" title="class in ch.javasoft.math.varint">IntVarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#TWO">TWO</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The VarInt constant two.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;<A HREF="../../../../ch/javasoft/math/varint/IntVarInt.html" title="class in ch.javasoft.math.varint">IntVarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#ZERO">ZERO</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The VarInt constant zero.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#abs()">abs</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a VarInt whose value is the absolute value of this
 VarInt.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#add(ch.javasoft.math.varint.VarInt)">add</A></B>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a VarInt whose value is <tt>(this + val)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#bitCount()">bitCount</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the number of bits in the two's complement representation
 of this VarInt that differ from its sign bit.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#bitLength()">bitLength</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the number of bits in the minimal two's-complement
 representation of this VarInt, <i>excluding</i> a sign bit.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;byte</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#byteValue()">byteValue</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the value of the specified number as a <code>byte</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#compact()">compact</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Tries to make this VarInt as compact as possible.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#divide(ch.javasoft.math.varint.VarInt)">divide</A></B>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a VarInt whose value is <tt>(this / val)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#divide(ch.javasoft.math.varint.VarInt, java.math.RoundingMode)">divide</A></B>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val,
             <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/math/RoundingMode.html" title="class or interface in java.math">RoundingMode</A>&nbsp;roundingMode)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a <tt>VarInt</tt> whose value is <tt>(this / val)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#divideAndRemainder(ch.javasoft.math.varint.VarInt)">divideAndRemainder</A></B>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns an array of two VarInts containing <tt>(this / val)</tt>
 followed by <tt>(this % val)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;double</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#doubleValue()">doubleValue</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the value of the specified number as a <code>double</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#equals(java.lang.Object)">equals</A></B>(<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;x)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Compares this VarInt with the specified Object for equality.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;float</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#floatValue()">floatValue</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the value of the specified number as a <code>float</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#gcd(ch.javasoft.math.varint.VarInt)">gcd</A></B>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a VarInt whose value is the greatest common divisor of
 <tt>abs(this)</tt> and <tt>abs(val)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#hashCode()">hashCode</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the hash code for this VarInt.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#intValue()">intValue</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the value of the specified number as an <code>int</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#isEven()">isEven</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns true if this is an even number, that is, if the least significant
 bit is zero.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#isNegative()">isNegative</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns true if this VarInt is negative</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#isNonNegative()">isNonNegative</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns true if this VarInt is not negative</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#isNonPositive()">isNonPositive</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns true if this VarInt is not positive</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#isOne()">isOne</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns true if this VarInt is one</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#isPositive()">isPositive</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns true if this VarInt is positive</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#isZero()">isZero</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns true if this VarInt is zero</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#longValue()">longValue</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the value of the specified number as a <code>long</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#max(ch.javasoft.math.varint.VarInt)">max</A></B>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the maximum of this VarInt and <tt>val</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#min(ch.javasoft.math.varint.VarInt)">min</A></B>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the minimum of this VarInt and <tt>val</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#mod(ch.javasoft.math.varint.VarInt)">mod</A></B>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;m)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a VarInt whose value is <tt>(this mod m</tt>).</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#multiply(ch.javasoft.math.varint.VarInt)">multiply</A></B>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a VarInt whose value is <tt>(this * val)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#negate()">negate</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a VarInt whose value is <tt>(-this)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#numberValue()">numberValue</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Conversion into a number value.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#pow(int)">pow</A></B>(int&nbsp;exponent)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a VarInt whose value is <tt>(this<sup>exponent</sup>)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#remainder(ch.javasoft.math.varint.VarInt)">remainder</A></B>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a VarInt whose value is <tt>(this % val)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#shiftLeft(int)">shiftLeft</A></B>(int&nbsp;n)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a VarInt whose value is <tt>(this &lt;&lt; n)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#shiftRight(int)">shiftRight</A></B>(int&nbsp;n)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a VarInt whose value is <tt>(this &gt;&gt; n)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;short</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#shortValue()">shortValue</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the value of the specified number as a <code>short</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#signum()">signum</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the signum function of this VarInt.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#subtract(ch.javasoft.math.varint.VarInt)">subtract</A></B>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a VarInt whose value is <tt>(this - val)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#testBit(int)">testBit</A></B>(int&nbsp;n)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns <tt>true</tt> if and only if the designated bit is set.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/math/BigInteger.html" title="class or interface in java.math">BigInteger</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#toBigInteger()">toBigInteger</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Conversion into a big integer value.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;byte[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#toByteArray()">toByteArray</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a byte array containing the two's-complement
 representation of this VarInt.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/String.html" title="class or interface in java.lang">String</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#toString()">toString</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the decimal String representation of this VarInt.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/String.html" title="class or interface in java.lang">String</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#toString(int)">toString</A></B>(int&nbsp;radix)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the String representation of this VarInt in the
 given radix.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#writeTo(java.io.OutputStream)">writeTo</A></B>(<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/OutputStream.html" title="class or interface in java.io">OutputStream</A>&nbsp;out)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Writes bytes to the output stream such that a VarInt can be reconstructed
 if read again.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Comparable"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from interface java.lang.<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Comparable.html#compareTo(T)" title="class or interface in java.lang">compareTo</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ FIELD DETAIL =========== -->

<A NAME="field_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Field Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="ZERO"><!-- --></A><H3>
ZERO</H3>
<PRE>
static final <A HREF="../../../../ch/javasoft/math/varint/IntVarInt.html" title="class in ch.javasoft.math.varint">IntVarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.24"><B>ZERO</B></A></PRE>
<DL>
<DD>The VarInt constant zero.
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="ONE"><!-- --></A><H3>
ONE</H3>
<PRE>
static final <A HREF="../../../../ch/javasoft/math/varint/IntVarInt.html" title="class in ch.javasoft.math.varint">IntVarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.29"><B>ONE</B></A></PRE>
<DL>
<DD>The VarInt constant one.
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="TWO"><!-- --></A><H3>
TWO</H3>
<PRE>
static final <A HREF="../../../../ch/javasoft/math/varint/IntVarInt.html" title="class in ch.javasoft.math.varint">IntVarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.34"><B>TWO</B></A></PRE>
<DL>
<DD>The VarInt constant two.
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="TEN"><!-- --></A><H3>
TEN</H3>
<PRE>
static final <A HREF="../../../../ch/javasoft/math/varint/IntVarInt.html" title="class in ch.javasoft.math.varint">IntVarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.39"><B>TEN</B></A></PRE>
<DL>
<DD>The VarInt constant ten.
<P>
<DL>
</DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="compact()"><!-- --></A><H3>
compact</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.44"><B>compact</B></A>()</PRE>
<DL>
<DD>Tries to make this VarInt as compact as possible.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="isZero()"><!-- --></A><H3>
isZero</H3>
<PRE>
boolean <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.50"><B>isZero</B></A>()</PRE>
<DL>
<DD>Returns true if this VarInt is zero
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>true if <code>this == 0</code></DL>
</DD>
</DL>
<HR>

<A NAME="isOne()"><!-- --></A><H3>
isOne</H3>
<PRE>
boolean <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.56"><B>isOne</B></A>()</PRE>
<DL>
<DD>Returns true if this VarInt is one
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>true if <code>this == 1</code></DL>
</DD>
</DL>
<HR>

<A NAME="isNegative()"><!-- --></A><H3>
isNegative</H3>
<PRE>
boolean <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.62"><B>isNegative</B></A>()</PRE>
<DL>
<DD>Returns true if this VarInt is negative
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>true if <code>this &lt; 0</code></DL>
</DD>
</DL>
<HR>

<A NAME="isPositive()"><!-- --></A><H3>
isPositive</H3>
<PRE>
boolean <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.68"><B>isPositive</B></A>()</PRE>
<DL>
<DD>Returns true if this VarInt is positive
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>true if <code>this &gt; 0</code></DL>
</DD>
</DL>
<HR>

<A NAME="isNonNegative()"><!-- --></A><H3>
isNonNegative</H3>
<PRE>
boolean <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.74"><B>isNonNegative</B></A>()</PRE>
<DL>
<DD>Returns true if this VarInt is not negative
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>true if <code>this &gt;= 0</code></DL>
</DD>
</DL>
<HR>

<A NAME="isNonPositive()"><!-- --></A><H3>
isNonPositive</H3>
<PRE>
boolean <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.80"><B>isNonPositive</B></A>()</PRE>
<DL>
<DD>Returns true if this VarInt is not positive
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>true if <code>this &lt;= 0</code></DL>
</DD>
</DL>
<HR>

<A NAME="isEven()"><!-- --></A><H3>
isEven</H3>
<PRE>
boolean <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.88"><B>isEven</B></A>()</PRE>
<DL>
<DD>Returns true if this is an even number, that is, if the least significant
 bit is zero.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>true if this VarInt is even</DL>
</DD>
</DL>
<HR>

<A NAME="testBit(int)"><!-- --></A><H3>
testBit</H3>
<PRE>
boolean <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.98"><B>testBit</B></A>(int&nbsp;n)</PRE>
<DL>
<DD>Returns <tt>true</tt> if and only if the designated bit is set.
 (Computes <tt>((this &amp; (1&lt;&lt;n)) != 0)</tt>.)
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>n</CODE> - index of bit to test.
<DT><B>Returns:</B><DD><tt>true</tt> if and only if the designated bit is set.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang">ArithmeticException</A></CODE> - <tt>n</tt> is negative.</DL>
</DD>
</DL>
<HR>

<A NAME="bitLength()"><!-- --></A><H3>
bitLength</H3>
<PRE>
int <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.110"><B>bitLength</B></A>()</PRE>
<DL>
<DD>Returns the number of bits in the minimal two's-complement
 representation of this VarInt, <i>excluding</i> a sign bit.
 For positive VarInt values, this is equivalent to the number of bits in
 the ordinary binary representation.  (Computes
 <tt>(ceil(log<sub>2</sub>(this &lt; 0 ? -this : this+1)))</tt>.)
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>number of bits in the minimal two's-complement
         representation of this VarInt, <i>excluding</i> a sign bit.</DL>
</DD>
</DL>
<HR>

<A NAME="bitCount()"><!-- --></A><H3>
bitCount</H3>
<PRE>
int <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.119"><B>bitCount</B></A>()</PRE>
<DL>
<DD>Returns the number of bits in the two's complement representation
 of this VarInt that differ from its sign bit.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>number of bits in the two's complement representation
         of this VarInt that differ from its sign bit.</DL>
</DD>
</DL>
<HR>

<A NAME="toBigInteger()"><!-- --></A><H3>
toBigInteger</H3>
<PRE>
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/math/BigInteger.html" title="class or interface in java.math">BigInteger</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.124"><B>toBigInteger</B></A>()</PRE>
<DL>
<DD>Conversion into a big integer value.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="numberValue()"><!-- --></A><H3>
numberValue</H3>
<PRE>
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.131"><B>numberValue</B></A>()</PRE>
<DL>
<DD>Conversion into a number value. Most implementations will simply
 return the <code>this</code> pointer since they already extends the
 <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang"><CODE>Number</CODE></A> class
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="add(ch.javasoft.math.varint.VarInt)"><!-- --></A><H3>
add</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.141"><B>add</B></A>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</PRE>
<DL>
<DD>Returns a VarInt whose value is <tt>(this + val)</tt>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>val</CODE> - value to be added to this VarInt.
<DT><B>Returns:</B><DD><tt>this + val</tt></DL>
</DD>
</DL>
<HR>

<A NAME="multiply(ch.javasoft.math.varint.VarInt)"><!-- --></A><H3>
multiply</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.149"><B>multiply</B></A>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</PRE>
<DL>
<DD>Returns a VarInt whose value is <tt>(this * val)</tt>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>val</CODE> - value to be multiplied by this VarInt.
<DT><B>Returns:</B><DD><tt>this * val</tt></DL>
</DD>
</DL>
<HR>

<A NAME="subtract(ch.javasoft.math.varint.VarInt)"><!-- --></A><H3>
subtract</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.157"><B>subtract</B></A>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</PRE>
<DL>
<DD>Returns a VarInt whose value is <tt>(this - val)</tt>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>val</CODE> - value to be subtracted from this VarInt.
<DT><B>Returns:</B><DD><tt>this - val</tt></DL>
</DD>
</DL>
<HR>

<A NAME="divide(ch.javasoft.math.varint.VarInt)"><!-- --></A><H3>
divide</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.166"><B>divide</B></A>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</PRE>
<DL>
<DD>Returns a VarInt whose value is <tt>(this / val)</tt>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>val</CODE> - value by which this VarInt is to be divided.
<DT><B>Returns:</B><DD><tt>this / val</tt>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang">ArithmeticException</A></CODE> - <tt>val==0</tt></DL>
</DD>
</DL>
<HR>

<A NAME="divide(ch.javasoft.math.varint.VarInt, java.math.RoundingMode)"><!-- --></A><H3>
divide</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.181"><B>divide</B></A>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val,
              <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/math/RoundingMode.html" title="class or interface in java.math">RoundingMode</A>&nbsp;roundingMode)</PRE>
<DL>
<DD>Returns a <tt>VarInt</tt> whose value is <tt>(this / val)</tt>. If 
 rounding must be performed to generate an integer result, the specified 
 rounding mode is applied.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>val</CODE> - value by which this <tt>divisor</tt> is to be divided.<DD><CODE>roundingMode</CODE> - rounding mode to apply.
<DT><B>Returns:</B><DD><tt>this / val</tt>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang">ArithmeticException</A></CODE> - if <tt>val</tt> is zero or if
         <tt>roundingMode==RoundingMode.UNNECESSARY</tt> and the result
         is not an integer.<DT><B>Since:</B></DT>
  <DD>1.5</DD>
</DL>
</DD>
</DL>
<HR>

<A NAME="divideAndRemainder(ch.javasoft.math.varint.VarInt)"><!-- --></A><H3>
divideAndRemainder</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>[] <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.194"><B>divideAndRemainder</B></A>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</PRE>
<DL>
<DD>Returns an array of two VarInts containing <tt>(this / val)</tt>
 followed by <tt>(this % val)</tt>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>val</CODE> - value by which this VarInt is to be divided, and the
               remainder computed.
<DT><B>Returns:</B><DD>an array of two VarInts: the quotient <tt>(this / val)</tt>
               is the initial element, and the remainder <tt>(this % val)</tt>
               is the final element.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang">ArithmeticException</A></CODE> - <tt>val==0</tt></DL>
</DD>
</DL>
<HR>

<A NAME="remainder(ch.javasoft.math.varint.VarInt)"><!-- --></A><H3>
remainder</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.204"><B>remainder</B></A>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</PRE>
<DL>
<DD>Returns a VarInt whose value is <tt>(this % val)</tt>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>val</CODE> - value by which this VarInt is to be divided, and the
               remainder computed.
<DT><B>Returns:</B><DD><tt>this % val</tt>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang">ArithmeticException</A></CODE> - <tt>val==0</tt></DL>
</DD>
</DL>
<HR>

<A NAME="pow(int)"><!-- --></A><H3>
pow</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.215"><B>pow</B></A>(int&nbsp;exponent)</PRE>
<DL>
<DD>Returns a VarInt whose value is <tt>(this<sup>exponent</sup>)</tt>.
 Note that <tt>exponent</tt> is an integer rather than a VarInt.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>exponent</CODE> - exponent to which this VarInt is to be raised.
<DT><B>Returns:</B><DD><tt>this<sup>exponent</sup></tt>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang">ArithmeticException</A></CODE> - <tt>exponent</tt> is negative.  (This would
               cause the operation to yield a non-integer value.)</DL>
</DD>
</DL>
<HR>

<A NAME="gcd(ch.javasoft.math.varint.VarInt)"><!-- --></A><H3>
gcd</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.225"><B>gcd</B></A>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</PRE>
<DL>
<DD>Returns a VarInt whose value is the greatest common divisor of
 <tt>abs(this)</tt> and <tt>abs(val)</tt>.  Returns 0 if
 <tt>this==0 &amp;&amp; val==0</tt>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>val</CODE> - value with which the GCD is to be computed.
<DT><B>Returns:</B><DD><tt>GCD(abs(this), abs(val))</tt></DL>
</DD>
</DL>
<HR>

<A NAME="abs()"><!-- --></A><H3>
abs</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.233"><B>abs</B></A>()</PRE>
<DL>
<DD>Returns a VarInt whose value is the absolute value of this
 VarInt.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD><tt>abs(this)</tt></DL>
</DD>
</DL>
<HR>

<A NAME="negate()"><!-- --></A><H3>
negate</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.240"><B>negate</B></A>()</PRE>
<DL>
<DD>Returns a VarInt whose value is <tt>(-this)</tt>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD><tt>-this</tt></DL>
</DD>
</DL>
<HR>

<A NAME="signum()"><!-- --></A><H3>
signum</H3>
<PRE>
int <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.248"><B>signum</B></A>()</PRE>
<DL>
<DD>Returns the signum function of this VarInt.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>-1, 0 or 1 as the value of this VarInt is negative, zero or
               positive.</DL>
</DD>
</DL>
<HR>

<A NAME="mod(ch.javasoft.math.varint.VarInt)"><!-- --></A><H3>
mod</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.262"><B>mod</B></A>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;m)</PRE>
<DL>
<DD>Returns a VarInt whose value is <tt>(this mod m</tt>).  This method
 differs from <tt>remainder</tt> in that it always returns a
 <i>non-negative</i> VarInt.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>m</CODE> - the modulus.
<DT><B>Returns:</B><DD><tt>this mod m</tt>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang">ArithmeticException</A></CODE> - <tt>m &lt;= 0</tt><DT><B>See Also:</B><DD><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#remainder(ch.javasoft.math.varint.VarInt)"><CODE>remainder(ch.javasoft.math.varint.VarInt)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="shiftLeft(int)"><!-- --></A><H3>
shiftLeft</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.274"><B>shiftLeft</B></A>(int&nbsp;n)</PRE>
<DL>
<DD>Returns a VarInt whose value is <tt>(this &lt;&lt; n)</tt>.
 The shift distance, <tt>n</tt>, may be negative, in which case
 this method performs a right shift.
 (Computes <tt>floor(this * 2<sup>n</sup>)</tt>.)
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>n</CODE> - shift distance, in bits.
<DT><B>Returns:</B><DD><tt>this &lt;&lt; n</tt><DT><B>See Also:</B><DD><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#shiftRight(int)"><CODE>shiftRight(int)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="shiftRight(int)"><!-- --></A><H3>
shiftRight</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.286"><B>shiftRight</B></A>(int&nbsp;n)</PRE>
<DL>
<DD>Returns a VarInt whose value is <tt>(this &gt;&gt; n)</tt>.  Sign
 extension is performed.  The shift distance, <tt>n</tt>, may be
 negative, in which case this method performs a left shift.
 (Computes <tt>floor(this / 2<sup>n</sup>)</tt>.)
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>n</CODE> - shift distance, in bits.
<DT><B>Returns:</B><DD><tt>this &gt;&gt; n</tt><DT><B>See Also:</B><DD><A HREF="../../../../ch/javasoft/math/varint/VarInt.html#shiftLeft(int)"><CODE>shiftLeft(int)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="equals(java.lang.Object)"><!-- --></A><H3>
equals</H3>
<PRE>
boolean <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.295"><B>equals</B></A>(<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;x)</PRE>
<DL>
<DD>Compares this VarInt with the specified Object for equality.
<P>
<DD><DL>
<DT><B>Overrides:</B><DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang">equals</A></CODE> in class <CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>x</CODE> - Object to which this VarInt is to be compared.
<DT><B>Returns:</B><DD><tt>true</tt> if and only if the specified Object is a
               VarInt whose value is numerically equal to this VarInt.</DL>
</DD>
</DL>
<HR>

<A NAME="min(ch.javasoft.math.varint.VarInt)"><!-- --></A><H3>
min</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.304"><B>min</B></A>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</PRE>
<DL>
<DD>Returns the minimum of this VarInt and <tt>val</tt>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>val</CODE> - value with which the minimum is to be computed.
<DT><B>Returns:</B><DD>the VarInt whose value is the lesser of this VarInt and 
               <tt>val</tt>.  If they are equal, either may be returned.</DL>
</DD>
</DL>
<HR>

<A NAME="max(ch.javasoft.math.varint.VarInt)"><!-- --></A><H3>
max</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.313"><B>max</B></A>(<A HREF="../../../../ch/javasoft/math/varint/VarInt.html" title="interface in ch.javasoft.math.varint">VarInt</A>&nbsp;val)</PRE>
<DL>
<DD>Returns the maximum of this VarInt and <tt>val</tt>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>val</CODE> - value with which the maximum is to be computed.
<DT><B>Returns:</B><DD>the VarInt whose value is the greater of this and
         <tt>val</tt>.  If they are equal, either may be returned.</DL>
</DD>
</DL>
<HR>

<A NAME="hashCode()"><!-- --></A><H3>
hashCode</H3>
<PRE>
int <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.322"><B>hashCode</B></A>()</PRE>
<DL>
<DD>Returns the hash code for this VarInt.
<P>
<DD><DL>
<DT><B>Overrides:</B><DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#hashCode()" title="class or interface in java.lang">hashCode</A></CODE> in class <CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></CODE></DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>hash code for this VarInt.</DL>
</DD>
</DL>
<HR>

<A NAME="toString(int)"><!-- --></A><H3>
toString</H3>
<PRE>
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/String.html" title="class or interface in java.lang">String</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.340"><B>toString</B></A>(int&nbsp;radix)</PRE>
<DL>
<DD>Returns the String representation of this VarInt in the
 given radix.  If the radix is outside the range from <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Character.html#MIN_RADIX" title="class or interface in java.lang"><CODE>Character.MIN_RADIX</CODE></A> to <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Character.html#MAX_RADIX" title="class or interface in java.lang"><CODE>Character.MAX_RADIX</CODE></A> inclusive,
 it will default to 10 (as is the case for
 <tt>Integer.toString</tt>).  The digit-to-character mapping
 provided by <tt>Character.forDigit</tt> is used, and a minus
 sign is prepended if appropriate.  (This representation is
 compatible with <A HREF="../../../../ch/javasoft/math/varint/VarIntFactory.html#create(java.lang.String, int)"><CODE>VarIntFactory.create(String, int)</CODE></A>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>radix</CODE> - radix of the String representation.
<DT><B>Returns:</B><DD>String representation of this VarInt in the given radix.<DT><B>See Also:</B><DD><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Integer.html#toString(int, int)" title="class or interface in java.lang"><CODE>Integer.toString(int, int)</CODE></A>, 
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Character.html#forDigit(int, int)" title="class or interface in java.lang"><CODE>Character.forDigit(int, int)</CODE></A>, 
<A HREF="../../../../ch/javasoft/math/varint/VarIntFactory.html#create(java.lang.String, int)"><CODE>VarIntFactory.create(java.lang.String, int)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="toString()"><!-- --></A><H3>
toString</H3>
<PRE>
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/String.html" title="class or interface in java.lang">String</A> <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.354"><B>toString</B></A>()</PRE>
<DL>
<DD>Returns the decimal String representation of this VarInt.
 The digit-to-character mapping provided by
 <tt>Character.forDigit</tt> is used, and a minus sign is
 prepended if appropriate.  This representation is compatible
 with <A HREF="../../../../ch/javasoft/math/varint/VarIntFactory.html#create(java.lang.String)"><CODE>VarIntFactory.create(String)</CODE></A>.
<P>
<DD><DL>
<DT><B>Overrides:</B><DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#toString()" title="class or interface in java.lang">toString</A></CODE> in class <CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></CODE></DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>decimal String representation of this VarInt.<DT><B>See Also:</B><DD><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Character.html#forDigit(int, int)" title="class or interface in java.lang"><CODE>Character.forDigit(int, int)</CODE></A>, 
<A HREF="../../../../ch/javasoft/math/varint/VarIntFactory.html#create(java.lang.String)"><CODE>VarIntFactory.create(String)</CODE></A>, 
<A HREF="../../../../ch/javasoft/math/varint/VarInt.html#toString(int)"><CODE>toString(int)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="toByteArray()"><!-- --></A><H3>
toByteArray</H3>
<PRE>
byte[] <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.369"><B>toByteArray</B></A>()</PRE>
<DL>
<DD>Returns a byte array containing the two's-complement
 representation of this VarInt.  The byte array will be in
 <i>big-endian</i> byte-order: the most significant byte is in
 the zeroth element.  The array will contain the minimum number
 of bytes required to represent this VarInt, including at
 least one sign bit. This representation is compatible with 
 <A HREF="../../../../ch/javasoft/math/varint/VarIntFactory.html#create(byte[])"><CODE>VarIntFactory.create(byte[])</CODE></A>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>a byte array containing the two's-complement representation of
               this VarInt.<DT><B>See Also:</B><DD><A HREF="../../../../ch/javasoft/math/varint/VarIntFactory.html#create(byte[])"><CODE>VarIntFactory.create(byte[])</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="writeTo(java.io.OutputStream)"><!-- --></A><H3>
writeTo</H3>
<PRE>
void <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.388"><B>writeTo</B></A>(<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/OutputStream.html" title="class or interface in java.io">OutputStream</A>&nbsp;out)
             throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD>Writes bytes to the output stream such that a VarInt can be reconstructed
 if read again. If the value contains at most 7 bits, only one byte is 
 written, containing the value directly. Otherwise, the bits 1 to 7 
 (ommiting the first bit) contains the number of bytes used to reconstruct the 
 value. The method is compatible with <A HREF="../../../../ch/javasoft/math/varint/VarIntFactory.html#readFrom(java.io.InputStream)"><CODE>VarIntFactory.readFrom(InputStream)</CODE></A>.
 <p>
 The bytes contain the two's-complement representation of this VarInt.  
 The bytes are written in <i>big-endian</i> byte-order: the most significant 
 byte is written first. Writes the minimum number of bytes required to represent 
 this VarInt, including at least one sign bit.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE> - if an I/O exception occurrs as a consequence of the 
                                                write operation<DT><B>See Also:</B><DD><A HREF="../../../../ch/javasoft/math/varint/VarIntFactory.html#readFrom(java.io.InputStream)"><CODE>VarIntFactory.readFrom(InputStream)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="intValue()"><!-- --></A><H3>
intValue</H3>
<PRE>
int <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.398"><B>intValue</B></A>()</PRE>
<DL>
<DD>Returns the value of the specified number as an <code>int</code>.
 This may involve rounding or truncation.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>the numeric value represented by this object after conversion
          to type <code>int</code>.</DL>
</DD>
</DL>
<HR>

<A NAME="longValue()"><!-- --></A><H3>
longValue</H3>
<PRE>
long <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.407"><B>longValue</B></A>()</PRE>
<DL>
<DD>Returns the value of the specified number as a <code>long</code>.
 This may involve rounding or truncation.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>the numeric value represented by this object after conversion
          to type <code>long</code>.</DL>
</DD>
</DL>
<HR>

<A NAME="floatValue()"><!-- --></A><H3>
floatValue</H3>
<PRE>
float <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.416"><B>floatValue</B></A>()</PRE>
<DL>
<DD>Returns the value of the specified number as a <code>float</code>.
 This may involve rounding.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>the numeric value represented by this object after conversion
          to type <code>float</code>.</DL>
</DD>
</DL>
<HR>

<A NAME="doubleValue()"><!-- --></A><H3>
doubleValue</H3>
<PRE>
double <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.425"><B>doubleValue</B></A>()</PRE>
<DL>
<DD>Returns the value of the specified number as a <code>double</code>.
 This may involve rounding.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>the numeric value represented by this object after conversion
          to type <code>double</code>.</DL>
</DD>
</DL>
<HR>

<A NAME="byteValue()"><!-- --></A><H3>
byteValue</H3>
<PRE>
byte <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.435"><B>byteValue</B></A>()</PRE>
<DL>
<DD>Returns the value of the specified number as a <code>byte</code>.
 This may involve rounding or truncation.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>the numeric value represented by this object after conversion
          to type <code>byte</code>.<DT><B>Since:</B></DT>
  <DD>JDK1.1</DD>
</DL>
</DD>
</DL>
<HR>

<A NAME="shortValue()"><!-- --></A><H3>
shortValue</H3>
<PRE>
short <A HREF="../../../../src-html/ch/javasoft/math/varint/VarInt.html#line.444"><B>shortValue</B></A>()</PRE>
<DL>
<DD>Returns the value of the specified number as a <code>short</code>.
 This may involve rounding or truncation.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>the numeric value represented by this object after conversion
          to type <code>short</code>.<DT><B>Since:</B></DT>
  <DD>JDK1.1</DD>
</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/VarInt.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../ch/javasoft/math/varint/LongVarInt.html" title="class in ch.javasoft.math.varint"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../ch/javasoft/math/varint/VarIntCache.html" title="interface in ch.javasoft.math.varint"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?ch/javasoft/math/varint/VarInt.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="VarInt.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
